import java.awt.*;
import java.awt.event.*;

class block
{
	boolean hole;
	String value;

	block(String b, boolean a){hole=a;value=b;}
	block(){hole=false;value="";}
}
public class puzzle extends Frame implements ActionListener, MouseListener, WindowListener
{
	MenuBar menuBar;
	Menu menu;
	MenuItem restart;
	MenuItem quit;
	MenuItem about;
	MenuItem high;

	block[][] field;
	private int turns=0;
	boolean done =false;
	boolean shownHigh=false;

	puzzleAbout frameAbout = new puzzleAbout();
	puzzleEntry frameEntry = new puzzleEntry(0);
	puzzleHigh frameHigh  = new puzzleHigh();

	private Image offScreenImage;

	public static void main(String[] args)
	{
		puzzle f = new puzzle();
		f.setSize(400,400);
		f.setVisible(true);

	}
	public puzzle()
	{
		setTitle("Puzzle");

		setLayout(new FlowLayout());



		field = new block[3][3];
		for(int i=0;i<3;i++)
		{
			for(int j=0;j<3;j++)
			{
				field[i][j] = new block();

			}
		}


		menuBar = new MenuBar();
		menu = new Menu("File");
		restart = new MenuItem("Restart");
		quit = new MenuItem("Quit");
		about = new MenuItem("About");
		high = new MenuItem("High Scores");

		restart.addActionListener(this);
		quit.addActionListener(this);
		about.addActionListener(this);
		high.addActionListener(this);

		menuBar.add(menu);
		menu.add(restart);
		menu.add(high);
		menu.add(quit);
		menu.add(about);

		addWindowListener(this);
		addMouseListener(this);
		setMenuBar(menuBar);

		reInit();
	}
	public void paint(Graphics g)
	{

		setBackground(Color.white);

			g.setColor(Color.black);
			g.drawRect(50,50,300,300);
			g.setColor(new Color(230,230,230));
			g.fillRect(51,51,298,298);
			g.setColor(new Color(200,200,200));
			
			g.fillRect(51,140,298,10);
			g.fillRect(51,240,298,10);
			g.fillRect(51,340,298,10);
			g.fillRect(140,50,10,300);
			g.fillRect(240,50,10,300);
			g.fillRect(340,50,10,300);
			g.setColor(Color.black);
			g.drawLine(150,50,150,350);
			g.drawLine(250,50,250,350);
			g.drawLine(50,150,350,150);
			g.drawLine(50,250,350,250);


			g.setFont(new Font("Serif",Font.BOLD,20));
			for(int i=0;i<3;i++)
			{
				for(int j=0;j<3;j++)
				{
					if(field[i][j].hole)
					{
						g.setColor(Color.gray);
						g.fillRect(j*100+50,i*100+50,100,100);
						g.setColor(Color.black);
					}
					if(field[i][j].value.compareTo(String.valueOf((char)((int)('A')-1)))!=0)
						g.drawString(field[i][j].value,100+j*100,130+i*100);
				}
			}
			g.setFont(new Font("Serif",Font.PLAIN,15));
			g.drawString("Turns: "+turns,300,390);

			if(done)
		{
			g.setColor(Color.black);
			g.setFont(new Font("Serif",Font.BOLD,30));
			g.drawString("Winner!",100,100);


		}
	}
	public void update(Graphics g)
	{
		Graphics gr;

		if (offScreenImage==null ||
                (! (offScreenImage.getWidth(this) == this.size().width
                && offScreenImage.getHeight(this) == this.size().height)))
        {
        offScreenImage = this.createImage(size().width, size().height);
        }

		gr = offScreenImage.getGraphics();
		setBackground(Color.white);
		gr.setColor(getBackground());
		gr.fillRect(0,0,400,400);
		gr.setColor(g.getColor());
		paint(gr);
		g.drawImage(offScreenImage,0,0,this);
	}
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource()==restart)
		{
			reInit();
		}
		if(e.getSource()==quit)
		{
			System.exit(0);
		}
		if(e.getSource()==about)
		{
			frameAbout.setVisible(true);
			frameAbout.setSize(200,200);
		}
		if(e.getSource()==high)
		{
			frameHigh.setVisible(true);
			frameHigh.setSize(300,400);
		}
	}
	public void checkDone()
	{
		done=true;
		String temp="";

		for(int i=0;i<3;i++)
		{
			for(int j=0;j<3;j++)
			{
				if(temp!="")
				{
					if(field[i][j].value.compareTo(temp)<0 && (i!=2 || j!=2))
					{
							done=false;
					}

				}
				temp=field[i][j].value;
			}
		}

		if(done)
		{
			repaint();
			frameEntry = new puzzleEntry(turns);
			frameEntry.setVisible(true);
			frameEntry.setSize(300,300);
		}
	}
	public void reInit()
	{
		turns=0;
		done=false;
		shownHigh=false;
		int letter = (int)('A')-1;

		for(int i=0;i<3;i++)
		{
			for(int j=0;j<3;j++)
			{
				field[i][j].value = String.valueOf((char)letter);
				field[i][j].hole=false;

				if((char)(letter+1) == 'A')
				{
					field[i][j].hole=true;
				}
				letter++;
			}
		}

		//randomize it
		int randRow,randCol;
		for(int i=0;i<3;i++)
		{
			for(int j=0;j<3;j++)
			{
				randRow = (int)(Math.random()*3);
				randCol = (int)(Math.random()*3);

				swap(field[i][j],field[randRow][randCol]);
			}
		}

		//set hole at top left corner
		for(int i=0;i<3;i++)
		{
			for(int j=0;j<3;j++)
			{
				if(field[i][j].value.compareTo(String.valueOf((char)((int)('A')-1)))==0)
					swap(field[0][0],field[i][j]);
			}
		}

		repaint();
	}
	public void mousePressed(MouseEvent e)
	{
		if(done) return;

		int row=-1, col=-1;
		if(e.getX()<150 && e.getX()>50)
		{
			col=1;


		}
		if(e.getX()>150 && e.getX()<250)
		{
			col=2;
		}
		if(e.getX()>250 && e.getX()<350)
		{
			col=3;
		}
		if(e.getY()>50 && e.getY()<150) row=1;
		if(e.getY()>150 && e.getY()<250) row=2;
		if(e.getY()>250 && e.getY()<350) row=3;

		if(row!=-1 && col!=-1)
		{
			for(int i=row-2;i<=row;i++)
			{
				for(int j=col-2;j<=col;j++)
				{
					if(i>-1 && i<field.length && j>-1 && j<field[0].length)
					{
						if(field[i][j].hole && (i==row-1 || j==col-1) && !(i==row-1 && j==col-1))
						{
							swap(field[i][j],field[row-1][col-1]);
							turns++;
							checkDone();
						}
					}
				}
			}
		}

		repaint();
	}
	public void swap(block a, block b)
	{
		block temp = new block(a.value,a.hole);

		a.value=b.value;
		a.hole=b.hole;
		b.value=temp.value;
		b.hole=temp.hole;
	}
	public void mouseReleased(MouseEvent e){}
	public void mouseClicked(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}

	public void windowClosing(WindowEvent e)
	{System.exit(0);
	}
	public void windowClosed(WindowEvent e){}
	public void windowOpened(WindowEvent e){}
	public void windowActivated(WindowEvent e){
		if(done && !frameEntry.isVisible() && !shownHigh){shownHigh=true;frameHigh.setVisible(true);frameHigh.setSize(300,400);}
	}
	public void windowDeactivated(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
}
